

#include "anicode.h"

#include "sphere.h"
#include "cylinder.h"
#include "spatch.h"
#include "sbfast.h"
#include "cone.h"


/* *************************************************************
************************************************************* */
buckey::buckey() {

   ob = new sphere;
   ob->id = object_counter;
   object_counter++;
}


/* *************************************************************
************************************************************* */
int buckey::query_whatwasi(int type) {

   return (buckey::query_whatami() == type) ? 1 : neutron::query_whatwasi(type);
}


/* *************************************************************
************************************************************* */
tube::tube() {

   ob = new cylinder;
   ob->id = object_counter;
   object_counter++;
}


/* *************************************************************
************************************************************* */
int tube::query_whatwasi(int type) {

   return (tube::query_whatami() == type) ? 1 : neutron::query_whatwasi(type);
}


/* *************************************************************
************************************************************* */
shell::shell() {

   ob = new spatch;
   ob->id = object_counter;
   object_counter++;
}


/* *************************************************************
************************************************************* */
int shell::query_whatwasi(int type) {

   return (shell::query_whatami() == type) ? 1 : neutron::query_whatwasi(type);
}


/* *************************************************************
************************************************************* */
helix::helix() {

   ob = new sbfast;
   ob->id = object_counter;
   object_counter++;
}


/* *************************************************************
************************************************************* */
int helix::query_whatwasi(int type) {

   return (helix::query_whatami() == type) ? 1 : neutron::query_whatwasi(type);
}


/* *************************************************************
************************************************************* */
funnel::funnel() {

   ob = new cone;
   ob->id = object_counter;
   object_counter++;
}


/* *************************************************************
************************************************************* */
int funnel::query_whatwasi(int type) {

   return (funnel::query_whatami() == type) ? 1 : neutron::query_whatwasi(type);
}

